Package org.eclipse.jgit.util.io

## Class EolCanonicalizingInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.eclipse.jgit.util.io.EolCanonicalizingInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

    public class EolCanonicalizingInputStream
    extends InputStream

An input stream which canonicalizes EOLs bytes on the fly to '\n'. Optionally, a binary check on the first 8000 bytes is performed and in case of binary files, canonicalization is turned off (for the complete file).

### Nested Class Summary

Nested Classes
`static class` `EolCanonicalizingInputStream.IsBinaryException` A special exception thrown when `EolCanonicalizingInputStream` is told to throw an exception when attempting to read a binary file.

### Constructor Summary

Constructors
`EolCanonicalizingInputStream​(InputStream in, boolean detectBinary)` Creates a new InputStream, wrapping the specified stream
`EolCanonicalizingInputStream​(InputStream in, boolean detectBinary, boolean abortIfBinary)` Creates a new InputStream, wrapping the specified stream

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `close()`
`boolean` `isBinary()`
`int` `read()`
`int` `read​(byte[] bs, int off, int len)`

### Methods inherited from class java.io.InputStream

`available, mark, markSupported, nullInputStream, read, readAllBytes, readNBytes, readNBytes, reset, skip, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### EolCanonicalizingInputStream

    public EolCanonicalizingInputStream​(InputStream in,
                                        boolean detectBinary)

Creates a new InputStream, wrapping the specified stream

Parameters:
  `in` - raw input stream
  `detectBinary` - whether binaries should be detected
Since:
  2.0

#### EolCanonicalizingInputStream

    public EolCanonicalizingInputStream​(InputStream in,
                                        boolean detectBinary,
                                        boolean abortIfBinary)

Creates a new InputStream, wrapping the specified stream

Parameters:
  `in` - raw input stream
  `detectBinary` - whether binaries should be detected
  `abortIfBinary` - throw an IOException if the file is binary
Since:
  3.3

### Method Detail

#### read

    public int read()
             throws IOException

Specified by:
  `read` in class `InputStream`
Throws:
  `IOException`

#### read

    public int read​(byte[] bs,
                    int off,
                    int len)
             throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`

#### isBinary

    public boolean isBinary()

Returns:
  true if the stream has detected as a binary so far
Since:
  3.3

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `InputStream`
Throws:
  `IOException`